######################################
# MORGANA CONFIRMATORY FACTOR ANALYSIS
######################################

# 1. Ensure that you are currently working in the directory that contains all the code files.
# 2. source("index.R")
# 3. Verify that all the functions from the MORGANA folder have been successfully loaded.


source("index.R")




# load "database.dat"

Z <- database
conver <- 0.0001
maxiter <- 100
display <- 1

# Items 
nrs <- ncol(Z)

#Factors present in the population
r <- 2

#The data is stored in X
N <- nrow(Z)
m <- ncol(Z)

# Pearson's R
cor <- 2
R <- cor(Z)

# Doublets 
doublets <- matrix(c(
  1, 2,
  6, 7
), ncol = 2, byrow = TRUE)
nd <- nrow(doublets)



# Extraction
result <- MorganaCFA(Z, r, conver, maxiter, cor, doublets)
A <- posit(result$A)
RESCOV <- result$RESCOV
RESCOR <- result$RESCOR
doubletsCFA <- result$doublets


# Goodness of Fit

result <- LoseferMorganaH0(A, RESCOR, doublets[, c(1, 2)], N, 5000)

v <- result$v
vv <- result$vv
a_n <- result$a_n
b1_n <- result$b1_n
b2_n <- result$b2_n
a_f <- result$a_f
b_f <- result$b_f
c_f <- result$c_f
d_f <- result$d_f


result <- LoseferMorgana(R, A, N, RESCOR, nd, v, vv, a_n, b1_n, b2_n, a_f, b_f, c_f, d_f, display)

Um1 <- result$Um
C0 <- result$C0
d1 <- result$d
d0 <- result$d0
RMSEA1 <- result$RMSEA
CFI1 <- result$CFI
TL1 <- result$TL


# Print solution

printsolMCFA(doubletsCFA, Um1, C0, d0, d1, RMSEA1, CFI1, TL1, A)
