
######################################
# MORGANA EXPLORATORY FACTOR ANALYSIS
######################################

# 1. Ensure that you are currently working in the directory that contains all the code files.
# 2. source("index.R")
# 3. Verify that all the functions from the MORGANA folder have been successfully loaded.

source("index.R")



# load "database.dat"

Z <- database
conver <- 0.0001
maxiter <- 100
display <- 1

# Items 
nrs <- ncol(Z)

#Factors present in the population
r <-2

#The data is stored in X
N <- nrow(Z)
m <- ncol(Z)

# Pearson's R
cor <- 2
R <- cor(Z)
if(cor==1){
  ccc <- "covariance"
} else{
  ccc <- "Pearson"
} 



#EXTRACTION
result <- MorganaEFA(Z, r, conver, maxiter, cor)
A <- posit(result$A)
RESCOV <- result$RESCOV
RESCOR <- result$RESCOR
doubletsEFA <- result$doublet
colnam<- c("P1", "P2", "EREC")
colnames(doubletsEFA) <- colnam
nd <- nrow(doubletsEFA)


#Goodness of fit indices

result <- LoseferMorganaH0(A, RESCOR, doubletsEFA[, c(1, 2)], N, 5000)

v <- result$v
vv <- result$vv
a_n <- result$a_n
b1_n <- result$b1_n
b2_n <- result$b2_n
a_f <- result$a_f
b_f <- result$b_f
c_f <- result$c_f
d_f <- result$d_f



result <- LoseferMorgana(R, A, N, RESCOR, nd, v, vv, a_n, b1_n, b2_n, a_f, b_f, c_f, d_f, display=0)



# rotation: provisional
# 
install.packages("psych")
install.packages("GPArotation")
library(psych)
library(GPArotation)
if(r>1){
  factor <- fa(RCOR, nfactors=r, n.obs=ncol(Z), covar=FALSE, rotate="none", fm="uls")
}else{
  factor <- fa(RCOR, nfactors=r, n.obs=ncol(Z), covar=FALSE, rotate="oblimin", fm="uls")
  
}



# Print Solution



printsolMEFA(doubletsEFA, result, factor)
