ginv <- function (A){
# ---------------------------------------------------------
# ** sweep : computes generalized inverse of a square 
# **         matrix 'A'.
# sweep(A)
# ---------------------------------------------------------
  fil <- nrow(A)
  col <- ncol(A)
  a <-matrix(0,fil,col)
  if (fil != col) 
      return (a)
  end

  eps <- 0.000000001
  if (max(A - t(A)) > eps )
     return (a)
  end

  for(i in 1: fil){
    for(j in 1: col){ 
       a[i,j] <- A[i,j]
    }
  }  

  rk <-matrix(0,fil,1)
  for(k in 1: col){
     d <- a[k,k]
     if (abs(d) < eps) {
        for(j in 1: col) a[k,j] <- 0.0
        for(j in 1: fil) a[j,k] <- 0.0
     } else {
        for(j in 1: col) a[k,j] <- a[k,j] / d
        for(j in 1: col) rk[j,1] <- a[k,j]
        for(i in 1: col) {
           if (i != k) {
              c <- a[i,k];
              for(j in 1: col) a[i,j] <- (a[i,j] - (c * rk[j,1]))
               a[i,k] <- -1.0 * c/d
           }
        }
     }
  }
  return (a)
}
