printsolMCFA <- function(doubletsCFA, Um, C0, d0, d, RMSEA1, CFI1, TL1, A ){
  cat("============================================================================\n")
  cat("              Morgana's Confirmatory Factor Analysis\n")
  cat("\n")
  cat("authors:  Hernandez-Dorado, A.; Lorenzo-Seva, U. & Ferrando, P.J., 2023\n")
  cat("============================================================================\n")
  cat("\n")
  cat("\n")
  cat("EREC for pairs of doublets\n") 
  cat("===============================\n")
  print(doubletsCFA)
  cat("\n")
  cat("\n")
  cat("\n")
  cat("Goodness of fit indices\n")
  cat("===============================\n")
  buff <- sprintf("Chi Square adjusted by Losefer with %i degrees of freedom = %.3f", d, Um)
  cat(buff)
  cat("\n")
  buff <- sprintf("Goodness of Fit (Null Model) = %.2f", C0)
  cat(buff)
  cat("\n")
  buff <- sprintf("Degrees of freedom =%.0f", d0)
  cat(buff)
  cat("\n")
  buff <- sprintf("RMSEA (Root Mean Square Error of Approximation)= %.3f", RMSEA1)
  cat(buff)
  cat("\n")
  buff <- sprintf("CFI (Comparative Fit Index)= %.3f", CFI1)
  cat(buff)
  cat("\n")
  buff <- sprintf("NNFI (Coeficiente de Tucker y Lewis)= %.3f", TL1)
  cat(buff)
  cat("\n")
  cat("\n")
  cat("\n")
  cat("Loadings\n")
  cat("===============================\n")
  print(A)
  cat("\n")
  cat("==================================================================\n")
  
}
