printsolMEFA <- function(doubletsEFA, result, factor ){
  
  Um <- result$Um
  C0 <- result$C0 
  d <- result$d
  d0 <- result$d0
  RMSEA1 <- result$RMSEA
  CFI1 <- result$CFI
  TL1 <- result$TL
  
  
    cat("=======================================================================\n")
    cat("                Morgana's Exploratory Factor Analysis\n")
    cat("\n")
    cat("\n")
    cat("                     Universitat Rovira i Virgili      \n")
    cat("\n")
    cat("\n")
    cat("authors: Hernandez-Dorado, A.; Lorenzo-Seva, U. & Ferrando, P.J., 2023\n")
    cat("=======================================================================\n")
    cat("\n")
    cat("\n")
    cat("=======================================================================\n")
    cat("\n")
    cat("\n")
    buff <- sprintf("n suj =%i", N) 
    cat(buff)
    cat("\n")
    buff <- sprintf("n items = %0i", nrs) 
    cat(buff)
    cat("\n")
    buff <- sprintf("n factors =%0i", r) 
    cat(buff)
    cat("\n")
    buff <- sprintf("cor =%s", ccc) 
    cat(buff)
    cat("\n")
    cat("\n")
    cat("\n")
    cat("=======================================================================\n")
    cat("\n")
    cat("\n")
    cat("\n")
    cat("EREC for pairs of doublets\n") 
    cat("===============================\n")
    print(doubletsEFA)
    cat("\n")
    cat("\n")
    cat("=======================================================================\n")
    cat("\n")
    cat("\n")
    cat("\n")
    cat("Goodness of fit indices\n")
    cat("===============================\n")
    buff <- sprintf("Chi Square adjusted by Losefer with %i degrees of freedom = %.3f", d, Um)
    cat(buff)
    cat("\n")
    buff <- sprintf("Goodness of Fit (Null Model) = %.2f", C0)
    cat(buff)
    cat("\n")
    buff <- sprintf("Degrees of freedom =%.0f", d0)
    cat(buff)
    cat("\n")
    buff <- sprintf("RMSEA (Root Mean Square Error of Approximation)= %.3f", RMSEA1)
    cat(buff)
    cat("\n")
    buff <- sprintf("CFI (Comparative Fit Index)= %.3f", CFI1)
    cat(buff)
    cat("\n")
    buff <- sprintf("NNFI (Tucker y Lewis Fit Index)= %.3f", TL1)
    cat(buff)
    cat("\n")
    cat("\n")
    cat("\n")
    cat("Loadings\n")
    cat("===============================\n")
    print(factor$loadings)
    cat("\n")
    cat("\n")
    cat("\n")
    if(r>1){
      cat("Phi\n")
      cat("===============================\n")
      print(factor$Phi)
      cat("\n")
      cat("\n")
      cat("\n")}
    
    cat("Residual Correlation Matrix\n")
    cat("===============================\n")
    print(RESCOR)
    cat("\n")
    cat("\n")
    cat("==================================================================\n")
    
    
  }
